/*
	$Id: RawDataProperty.java 4889 2009-04-06 12:52:39Z nicklas $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

/**
	Holds information about an extended property for raw data.

	@see ExtendedProperty
	@author Nicklas
	@version 2.0
	@base.modified $Date: 2009-04-06 14:52:39 +0200 (Mon, 06 Apr 2009) $
*/
public class RawDataProperty
	extends ExtendedProperty
{
	private final int channel;

	/**
		Create a new rawdata property.
		See the getter methods for a description of the parameters.
	*/
	RawDataProperty(String name, String title, String description, String column,
		Type type, int length, boolean nullable, Formula.AverageMethod averageMethod, int channel)
	{
		super(name, title, description, column, type, length, nullable, true, false, averageMethod, null);
		this.channel = channel;
	}

	/**
		Get the channel this property belongs to.
		@return The channel number, or zero if it doesn't belong to any particular channel
	*/
	public int getChannel()
	{
		return channel;
	}

}

