/*
	$Id $

	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

import java.util.List;
import java.util.ArrayList;
import java.util.Date;

/**
	Date+time parameter value.

	@author Nicklas
	@since 2.16
	@see <a href="../../../../../../html/developer/api/data_api.parameters.html">Developer documentation: Parameters</a>
	@hibernate.subclass discriminator-value="11"
	@base.modified $Date $
*/
public class TimestampParameterValueData
	extends ParameterValueData<Date>
{
	public TimestampParameterValueData()
	{}
	
	public TimestampParameterValueData(Date... values)
	{
		super(values);
	}
	
	/**
		@return 9 (Type.TIMESTAMP)
		@since 2.16
	*/
	public int getValueType()
	{
		return 9;
	}

	private List<Date> values;
	/**
		@hibernate.bag table="`TimestampValues`" lazy="true" cascade="all"
		@hibernate.collection-key column="`id`"
		@hibernate.collection-element column="`value`" type="timestamp" not-null="true"
	*/
	public List<Date> getValues()
	{
		if (values == null )
		{
			values = new ArrayList<Date>();
		}
		return values;
	}
	void setValues(List<Date> values)
	{
		this.values = values;
	}

	public String toString()
	{
		return values.toString();
	}	
}
