<%-- $Id: index.jsp 5663 2011-06-22 14:03:17Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.10
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.BioMaterialList"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.OwnedItem"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemAlreadyExistsException"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.util.RemovableUtil"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.util.OwnableUtil"
	import="net.sf.basedb.util.collections.CollectionTransformer"
	import="net.sf.basedb.util.biomaterial.ListUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.edit.OnSaveRenderer"
	import="java.util.Enumeration"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.Collections"
	import="java.util.Arrays"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
	private static final ItemContext defaultContext = Base.createDefaultContext("name", "name,memberType,size,description");
	private static final Item itemType = Item.BIOMATERIALLIST;
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final String mode = request.getParameter("mode");
final String callback = request.getParameter("callback");
final String itemId = request.getParameter("item_id");
final String listPage = "list_lists.jsp?ID="+ID
	+(mode == null ? "" : "&mode="+mode)
	+(callback == null ? "" : "&callback="+callback)
	+(itemId == null ? "" : "&item_id="+itemId);
final String viewPage = "view_list.jsp?ID="+ID;
final String editPage = "edit_list.jsp?ID="+ID;

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;

try
{
	if (cmd == null || "List".equals(cmd))
	{
		// Display the list page without updatinging the current context
		Base.getAndSetCurrentContext(sc, itemType, null, defaultContext, true);
		redirect = listPage;
	}
	else if ("UpdateContext".equals(cmd))
	{
		// Display the list page after updating the current context from the request parameters
		Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = listPage;
	}
	else if ("LoadContext".equals(cmd))
	{
		// Display the list page after loading a saved context
		int contextId = Values.getInt(request.getParameter("context"));
		Base.loadContext(sc, contextId, defaultContext);
		redirect = listPage;
	}

	else if ("ViewItem".equals(cmd))
	{
		// Display the view page for a single item 
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		forward = viewPage;
	}
	else if ("EditItem".equals(cmd))
	{
		// Display the edit page for a single item (should be opened in a popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = editPage;
	}
	else if ("NewItem".equals(cmd))
	{
		// Display the edit page for a new item (should be opened in a popup)
		if (!sc.hasPermission(Permission.CREATE, itemType))
		{
			throw new PermissionDeniedException(Permission.CREATE, itemType.toString());
		}
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		cc.setId(0);
		forward = editPage;
	}
	else if ("UpdateItem".equals(cmd))
	{
		// Update the properties on an item (will close the popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, defaultContext);
		dc = sc.newDbControl();
		BioMaterialList list = (BioMaterialList)cc.getObject("item");
		if (list == null)
		{
			Item memberType = Item.valueOf(request.getParameter("memberType"));
			list = BioMaterialList.getNew(dc, memberType);
			dc.saveItem(list);
			message = "List created";
		}
		else
		{
			dc.reattachItem(list, false);
			message = "List updated";
		}
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(Item.BIOMATERIALLIST), list);
		ExtensionsInvoker invoker = EditUtil.useOnSaveExtensions(jspContext);
		try
		{
			if (!list.isInDatabase())
			{
				// Add individual items from selected from a list page
				String source = request.getParameter("source");
				if (source != null)
				{
					Item fromContext = Item.valueOf(request.getParameter("fromContext"));
					String subContext = Values.getString(request.getParameter("subContext"), "");
					boolean pooled = Values.getBoolean(request.getParameter("pooled"));
					
					ItemQuery<? extends BioMaterial> query = 
						(ItemQuery<? extends BioMaterial>)sc.getCurrentContext(fromContext, subContext).getQuery();
					if ("all".equals(source))
					{
						query.setFirstResult(0);
						query.setMaxResults(-1);
					}
					else if ("selected".equals(source))
					{
						query.setFirstResult(0);
						query.setMaxResults(-1);
						Integer[] itemIds = Values.getInt(request.getParameter("items").split(","));
						query.restrict(
							Restrictions.in(
								Hql.property("id"),
								Expressions.parameter("_selected_")
							)
						);
						query.setParameter("_selected_", Arrays.asList(itemIds), Type.INT);			
					}
					// else -- no modifications to the query mean that we only get the current page
					
					// This is our list of source items (eg. the selected items in the list)
					List<? extends BioMaterial> sources = query.list(dc);
					// Create a transformer that takes the source list and finds related
					// items
					CollectionTransformer transformer = 
						ListUtil.createTransformer(dc, fromContext, list.getMemberType(), pooled);
					int numAdded = ListUtil.addToList(list, sources, transformer);
				}
				
				// Add items from other lists?
				String create = Values.getStringOrNull(request.getParameter("create"));
				if (create != null)
				{
					List<BioMaterialList> lists = new ArrayList<BioMaterialList>(cc.getSelected().size());
					for (int listId : cc.getSelected())
					{
						lists.add(BioMaterialList.getById(dc, listId));
					}
					if ("union".equals(create))
					{
						list.addUnion(lists);
					}
					else if ("intersection".equals(create))
					{
						list.addIntersection(lists);
					}
					else if ("count".equals(create))
					{
						int minCount = Values.getInt(request.getParameter("minCount"), 1);
						list.addIfPresentIn(minCount, lists.size(), lists);
					}
				}
				message = "Biomaterial list created with " + list.getSize() + " item(s)";
			}
			
			list.setName(Values.getStringOrNull(request.getParameter("name")));
			list.setExternalId(Values.getStringOrNull(request.getParameter("external_id")));
			list.setDescription(Values.getStringOrNull(request.getParameter("description")));

			// OnSave extensions
			invoker.render(OnSaveRenderer.ON_SAVE);
			dc.commit();
			invoker.render(OnSaveRenderer.ON_COMMIT);
		}
		catch (Exception ex)
		{
			invoker.render(OnSaveRenderer.onRollback(ex));
			throw ex;
		}
		finally
		{
			cc.removeObject("item");
		}
	}
	else if ("DeleteItem".equals(cmd))
	{
		// Delete a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.setRemoved(dc, itemType, Collections.singleton(cc.getId()), true);
		dc.commit();
		redirect = viewPage;
	}
	else if ("DeleteItems".equals(cmd))
	{
		// Delete all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int numRemoved = RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), true);
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be deleted, because you have no DELETE permission";
		}
		redirect = listPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
	}
	else if ("RestoreItem".equals(cmd))
	{
		// Restore a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.setRemoved(dc, itemType, Collections.singleton(cc.getId()), false);
		dc.commit();
		redirect = viewPage;
	}
	else if ("RestoreItems".equals(cmd))
	{
		// Restore all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int numRemoved = RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), false);
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be restored, because you have no WRITE permission";
		}
		redirect = listPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
	}
	else if ("ShareItem".equals(cmd))
	{
		// Display a popup window for sharing a single item
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, Collections.singleton(cc.getId()));
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("ShareItems".equals(cmd))
	{
		// Display a popup window for sharing all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, cc.getSelected());
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("SetOwnerOfItem".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		OwnedItem item = (OwnedItem)itemType.getById(dc, cc.getId());
		cc.setObject("OwnedItems", Collections.singleton(item));
		redirect = "../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("SetOwnerOfItems".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		Set<OwnedItem> items = new HashSet<OwnedItem>();
		for (Integer id : cc.getSelected())
		{
			if (id != null) items.add((OwnedItem)itemType.getById(dc, id));
		}
		dc.close();
		cc.setObject("OwnedItems", items);
		redirect = "../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("ExportItems".equals(cmd))
	{
		// Run an export plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<BioMaterialList> query = BioMaterialList.getQuery();
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Export+biomaterial+lists";
	}
	else if ("ExportItem".equals(cmd))
	{
		// Run an export plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Export+label";
	}
	else if ("ImportItems".equals(cmd))
	{
		// Run an import plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<BioMaterialList> query = BioMaterialList.getQuery();
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Import+biomaterial+lists";
	}
	else if ("ImportItem".equals(cmd))
	{
		// Run an import plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Import+label";
	}
	else if ("RunListPlugin".equals(cmd))
	{
		// Run another plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<BioMaterialList> query = BioMaterialList.getQuery();
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&main_type=OTHER&title=Run+plugin";
	}
	else if ("RunPlugin".equals(cmd))
	{
		// Run another plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&main_type=OTHER&title=Run+plugin";
	}
	else if ("MergeItem".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, defaultContext);
		dc = sc.newDbControl();
		BioMaterialList bl = (BioMaterialList)cc.getObject("item");
		dc.reattachItem(bl, false);
		
		String mergeType = request.getParameter("mergeType");
		String sourceMerge = request.getParameter("sourceMerge");
		
		String[] sourceListIds = Values.getString(request.getParameter("sourceLists")).split(",");
		List<BioMaterialList> sourceLists = new ArrayList<BioMaterialList>(sourceListIds.length);
		for (int i = 0; i < sourceListIds.length; ++i)
		{
			int listId = Values.getInt(sourceListIds[i], -1);
			if (listId != -1) sourceLists.add(BioMaterialList.getById(dc, listId));
		}
		
		int numAdded = 0;
		int numRemoved = 0;
		if ("union".equals(mergeType))
		{
			if ("union".equals(sourceMerge))
			{
				numAdded = bl.addUnion(sourceLists);
			}
			else if ("intersection".equals(sourceMerge))
			{
				numAdded = bl.addIntersection(sourceLists);
			}
			message = numAdded + " items added to this list";
		}
		else if ("intersection".equals(mergeType))
		{
			if ("union".equals(sourceMerge))
			{
				numRemoved = bl.retainUnion(sourceLists);
			}
			else if ("intersection".equals(sourceMerge))
			{
				numRemoved = bl.retainIntersection(sourceLists);
			}
			message = numRemoved + " items removed from this list";
		}
		else if ("complement".equals(mergeType))
		{
			if ("union".equals(sourceMerge))
			{
				numRemoved = bl.removeUnion(sourceLists);
			}
			else if ("intersection".equals(sourceMerge))
			{
				numRemoved = bl.removeIntersection(sourceLists);
			}
			message = numRemoved + " items removed from this list";
		}
		dc.commit();
	}	
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	pageContext.forward(forward);
}
else if (redirect != null)
{
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

