<%-- $Id: list_directories.jsp 5555 2011-01-27 13:57:28Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.FileUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%!
String generateSubTree(Map<Directory, List<Directory>> tree, Set<Directory> ignore, Directory parent, String ID, String parentId)
{
	if (ignore.contains(parent)) return "";
	ignore.add(parent);
	StringBuilder sb = new StringBuilder();
	if (parentId == null) parentId = "dir"+parent.getId();
	List<Directory> children = tree.get(parent);
	if (children == null) return "";
	for (Directory child : children)
	{
		if (ignore.contains(child)) continue;
		String folderIcon = "Folder";
		if (child.isHomeDirectory())
		{
			folderIcon = "UserHome";
		}
		else if (child.isRemoved())
		{
			folderIcon = "FolderDeleted";
		}
		else if (child.getAutoCompress())
		{
			folderIcon = "FolderCompressed";
		}
		sb.append("var dir").append(child.getId()).append(" = JoustMenu.addLazyChildItem(").append(parentId);
		sb.append(",'").append(folderIcon).append("'");
		sb.append(",'").append(HTML.javaScriptEncode(child.getName())).append("'");
		sb.append(",'directoryOnClick(").append(child.getId()).append(",");
		sb.append(" \"").append(HTML.javaScriptEncode(child.getPath().toString())).append("\")'");
		sb.append(",'', 'D").append(child.getId()).append("',");
		sb.append("'lazyInitSubdir(").append(child.getId()).append(")')\n");
		sb.append(generateSubTree(tree, ignore, child, ID, null));
	}
	return sb.toString();
}
%>
<%
final Item itemType = Item.DIRECTORY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
final String mode = request.getParameter("mode");
final String callback = request.getParameter("callback");
final float scale = Base.getScale(sc);
final String requestTitle = request.getParameter("title");
final boolean syncWithDirectory = Values.getBoolean(request.getParameter("sync"));
final ItemContext cc = sc.getCurrentContext(itemType);
int directoryId = cc.getId();
try
{
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final Directory userHome = user.getHomeDirectory();
	final boolean readDirectories = sc.hasPermission(Permission.READ, Item.DIRECTORY);
	final Directory root = Directory.getById(dc, SystemItems.getId(readDirectories ? Directory.ROOT : Directory.HOME));
	
	Directory current = null;
	// Try to get current/last visited directory. If not successful, use default directory.
	try
	{
		current = directoryId != 0 ? Directory.getById(dc, directoryId) : null;
	}
	catch (Throwable ex){}	
	if (current == null) current = userHome;
	if (current == null) current = root;
	
	final String rootIcon;
	final String rootTitle;
	if (root.isRootDirectory())
	{
		rootIcon = "Root";
		rootTitle = "Root";
	}
	else
	{
		rootIcon = "Home";
		rootTitle = "Other users";
	}
	Map<Directory, List<Directory>> tree = FileUtil.loadMinimalDirectoryTree(dc, root, userHome, current);
	Set<Directory> ignore = new HashSet<Directory>();
	%>
	<base:page title="<%=requestTitle != null ? requestTitle : ""%>" type="popup">
	<base:head scripts="newjoust.js,table.js,ajax.js,json2.js" styles="newjoust.css,toolbar.css">
	<script language="JavaScript">
	var isInitialised = false;
	function initialise() 
	{
		if (parent && parent.parent && parent.parent.adjustIFrameSize) parent.parent.adjustIFrameSize();
		IconStore.init();
		var path = getRoot()+'images/joust/';
		IconStore.addIcon('Search', path + 'search.png', 18, 16);
		IconStore.addIcon('SearchSelected', path + 'searchselected.png', 18, 16);
		<%
		// Root entry for the user's Home directory
		if (userHome != null)
		{
			%>
			var userHome = JoustMenu.addMenuItem(-1, 'Home', 'My home', 'directoryOnClick(<%=userHome.getId()%>, "<%=HTML.javaScriptEncode(userHome.getPath().toString())%>")', '', 'D<%=userHome.getId()%>');
			JoustMenu.menuItems[userHome].noOutlineIcon = true;
			JoustMenu.menuItems[userHome].isOpen = true;
			<%=generateSubTree(tree, ignore, userHome, ID, "userHome")%>
			<%
		}
		// Root entry for entire directory tree
		%>
		var search = JoustMenu.addMenuItem(-1, 'Search', 'Search results', 'searchOnClick()', 'The latest search results', 'search');
		JoustMenu.menuItems[search].noOutlineIcon = true;
		JoustMenu.menuItems[search].style = 'display:none; font-style: italic; border-bottom: 1px solid #cccccc; margin-bottom: 2px; padding-bottom: 2px;';
		var root = JoustMenu.addMenuItem(-1, '<%=rootIcon%>', '<%=HTML.javaScriptEncode(rootTitle)%>', 'directoryOnClick(<%=root.getId()%>, "<%=HTML.javaScriptEncode(root.getPath().toString())%>")', '', 'D<%=root.getId()%>');
		JoustMenu.menuItems[root].noOutlineIcon = true;
		JoustMenu.menuItems[root].isOpen = true;
		<%=generateSubTree(tree, ignore, root, ID, "root")%>

		<%
		// Add 'current' as root entry if we have not seen it before
		if (!ignore.contains(current))
		{
			// but... move up as far as the user has 'read' permission...
			Directory currentRoot = current;
			try
			{
				while (currentRoot != null && !ignore.contains(currentRoot.getParent()))
				{
					currentRoot = currentRoot.getParent();
				}
			}
			catch (Throwable t)
			{}
			if (currentRoot == null) currentRoot = current;
			%>
			var currentRoot = JoustMenu.addMenuItem(-1, 'Folder', '<%=HTML.javaScriptEncode(currentRoot.getPath().toString())%>', 'directoryOnClick(<%=currentRoot.getId()%>, "<%=HTML.javaScriptEncode(currentRoot.getPath().toString())%>")', '', 'D<%=currentRoot.getId()%>');
			JoustMenu.menuItems[currentRoot].noOutlineIcon = true;
			JoustMenu.menuItems[currentRoot].isOpen = true;
			<%=generateSubTree(tree, ignore, currentRoot, ID, "currentRoot")%>
			<%
		}
		%>
		JoustMenu.draw('joust');
		var lastDirectory = JoustMenu.menuItems['D<%=current.getId()%>'];
		JoustMenu.select(lastDirectory.index);
		JoustMenu.alwaysSendOnClickToSelected = true;
		isInitialised = true;
	}
	
	function lazyInitSubdir(directoryId)
	{
		var request = Ajax.getXmlHttpRequest();
		var url = 'ajax.jsp?ID=<%=ID%>&cmd=GetSubdirectories&item_id=' + directoryId;
		request.open("GET", url, false); 
		// NOTE! 'false' causes code to wait for the response. aka. 'Synchronous AJAX' or SJAX.
		request.send(null);
		var response = Ajax.parseJsonResponse(request.responseText);
		if (response.status != 'ok')
		{
			alert(response.message);
			return false;
		}
		
		var subdirs = response.subdirs;
		var numAdded = 0;
		var parent = JoustMenu.menuItems['D'+directoryId];
		for (var i = 0; i < subdirs.length; i++)
		{
			var subdir = subdirs[i];
			var id = subdir.id;
			var folderIcon = 'Folder';
			if (subdir.isHome)
			{
				folderIcon = 'UserHome';
			}
			else if (subdir.isRemoved)
			{
				folderIcon = 'FolderDeleted';
			}
			else if (subdir.isAutoCompress == 1)
			{
				folderIcon = 'FolderCompressed';
			}
			numAdded++;
			JoustMenu.addLazyChildItem(parent.index, folderIcon, subdir.name, 'directoryOnClick('+id+',\''+subdir.path+'\')', '', 'D'+id, 'lazyInitSubdir('+id+')');
		}
		return numAdded > 0;
	}
	<%
	if ("selectonedirectory".equals(mode))
	{
		%>
		var lastDirectoryId;
		function directoryOnClick(directoryId, path)
		{
			var frm = document.forms['directory'];
			frm.directory_id.value = directoryId;
			frm.path.value = path;
			lastDirectoryId = directoryId;
		}
		function returnSelected()
		{
			var frm = document.forms['directory'];
			top.window.opener.<%=callback%>(frm.directory_id.value, frm.path.value);
			top.window.close();
		}
		function newDirectory()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', 0, true, '&parent_id='+lastDirectoryId);
		}
		<%
	}
	else
	{
		%>
		function directoryOnClick(directoryId, path)
		{
			if (!isInitialised && <%=!syncWithDirectory%>) return;
			parent.lastOpenDirectoryId = directoryId;
			parent.frames.files.location.href = '../files/index.jsp?ID=<%=ID%>&cmd=List&directory_id='+directoryId+'&mode=<%=mode%>';
			if (window.top.setSelected)
			{
				window.top.setSelected('', path);
			}
		}
		<%
	}
	%>
	function searchOnClick()
	{
		parent.frames.files.location.href = '../files/index.jsp?ID=<%=ID%>&cmd=Search&subcontext=search&mode=<%=mode%>';
	}
	function searchButtonOnClick()
	{
		var searchResults = JoustMenu.menuItems['search'];
		Main.show('menuItem'+searchResults.index);
		JoustMenu.select(searchResults.index, null, false);
	}
	function updateSearchResults(files, directories)
	{
		var searchResults = JoustMenu.menuItems['search'];
		if (searchResults)
		{
			var text = document.getElementById('text'+searchResults.index);
			text.innerHTML = 'Search results (' + (files + directories) + ')';
		}
	}
	function synchronizeTo(directoryId, parentId)
	{
		var item = JoustMenu.menuItems['D'+directoryId];
		if (!item)
		{
			if (!parentId) parentId = parent.lastOpenDirectoryId;
			if (parentId)
			{
				var parentDir = JoustMenu.menuItems['D'+parentId];
				if (parentDir.lazyInit) 
				{
					JoustMenu.toggle(parentDir.index);
					item = JoustMenu.menuItems['D'+directoryId];
				}
			}
		}
		if (item) 
		{
			JoustMenu.select(item.index);
		}
		else
		{
			parent.parent.location.href = '../directories/index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=' + directoryId+'&mode=<%=mode%>';
		}
	}
	function refresh()
	{
		location.reload();
	}
	</script>
	</base:head>
	
	<%
	if ("selectonedirectory".equals(mode))
	{
		%>
		<base:body onload="initialise()"
			style="padding-left: 0px; padding-right: 0px;"
			>
			<div id="main" class="joust" style="width:100%;">
				<h3 class="docked"><%=requestTitle == null ? "Select one directory" : requestTitle%></h3>
				<tbl:toolbar>
					<tbl:button 
						image="directory_new.gif" 
						onclick="newDirectory()" 
						title="New&hellip;" 
						tooltip="Create a new directory" 
					/>
				</tbl:toolbar>
				<div id="joust" class="boxedbottom" style="height: <%=(int)(scale*340)%>px; overflow:auto; background: #E0E0E0;">
				</div>
			</div>
			
			<form name="directory">
			<br>
			<input type="hidden" name="directory_id" value="">
			<b><%=requestTitle == null ? "Path" : requestTitle%></b> <input type="text" class="text" readonly name="path" size="40">
			<p>
			<table align="center">
			<tr>
				<td width="50%"><base:button onclick="returnSelected()" title="Ok" /></td>
				<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
			</tr>
			</table>
			</form>
		</base:body>
		<%
	}
	else
	{
		%>
		<base:body onload="initialise()" 
			style="padding-left: 0px; padding-right: 0px;" >
		<div id="main" class="joust" style="width:100%;">
			<tbl:toolbar>
				<tbl:button 
					image="refresh.gif" 
					onclick="refresh()" 
					title="Refresh" 
					tooltip="Refresh the directory tree" 
				/>
				<tbl:button 
					image="search.png" 
					onclick="searchButtonOnClick()" 
					title="Search" 
					tooltip="Search for files and directories" 
				/>
			</tbl:toolbar>
			<div id="joust" class="boxedbottom" style="overflow: auto;">
			</div>
		</div>
		</base:body>
		<%
	}
	%>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
